searchNodes=[{"doc":"There are two main ways of using imageflow_ex:Imageflow.Graph, which is the high-level graph-like API, inspired by [Imageflow.NET](https://github.com/imazen/imageflow-dotnet]Imageflow.Native which provibes lower-level access to Rust binding. Shouldn't be needed unless you need really specific features which aren't yet implemented in the Graph API (but please open an issue so the API can evolve).","ref":"Imageflow.html","title":"Imageflow","type":"module"},{"doc":"Returns the version string of the current imageflow Rust crate being used","ref":"Imageflow.html#get_long_version_string/0","title":"Imageflow.get_long_version_string/0","type":"function"},{"doc":"With the Graph API, you can specify a task to process multiple inputs/outputs according to a pipeline of operations.For example:alias Imageflow.GraphGraph.new() |&gt; Graph.decode_file(&quot;input.png&quot;) # read input.png |&gt; Graph.constrain(200, 200) # constrain image to 200x200 |&gt; Graph.saturation(0.5) # set saturation to 0.5 (-1..1 range) |&gt; Graph.encode_to_file(&quot;output.png&quot;) # specify output file |&gt; Graph.run() # run the job ```Within a Graph, you specify all the operations, inputs and outputs you need. Only when Graph.run/1 is called is this actually executedYou can also specify multiple outputs, which is a common use-case. For example, for web/mobile development, you may want to generate multiple images with different resolutions for responsive apps:alias Imageflow.Graph Graph.new() |&gt; Graph.decode_file(@input_path) |&gt; Graph.branch(fn graph -&gt; # 2160px wide image for retina displays graph graph |&gt; Graph.constrain(2160, nil) |&gt; Graph.encode_to_file(&quot;desktop@2x.png&quot;) end) |&gt; Graph.branch(fn graph -&gt; # 1080px wide image for desktop graph |&gt; Graph.constrain(1080, nil) |&gt; Graph.encode_to_file(&quot;desktop.png&quot;) end) |&gt; Graph.branch(fn graph -&gt; # 720px wide image for tablet graph |&gt; Graph.constrain(720, nil) |&gt; Graph.encode_to_file(&quot;tablet.png&quot;) end) |&gt; Graph.branch(fn graph -&gt; # 600px wide image for mobile graph |&gt; Graph.constrain(600, nil) |&gt; Graph.encode_to_file(&quot;mobile.png&quot;) end) |&gt; Graph.run()The above snippet will generate 4 images, all processed under the same imageflow job.Check the documentation to see what other operations are availableYou may also want to check the base repo for imageflow, or its live JSON API documentation","ref":"Imageflow.Graph.html","title":"Imageflow.Graph","type":"module"},{"doc":"Creates a new branch, allowing you do add multiple paths and outputs to the graphIf you need to output multiple formats, this is what you should use. Perform all common operations first, then call a branch with each specialized part and its corresponding output","ref":"Imageflow.Graph.html#branch/2","title":"Imageflow.Graph.branch/2","type":"function"},{"doc":"Adjusts brightness betweeen -1 and 1","ref":"Imageflow.Graph.html#brightness/2","title":"Imageflow.Graph.brightness/2","type":"function"},{"doc":"Applies a color filter to the image. All filters will operate on the sRGB color space, so may not provide ideal results.Check the JSON API documentation for available filters.","ref":"Imageflow.Graph.html#color_filter/2","title":"Imageflow.Graph.color_filter/2","type":"function"},{"doc":"Constrains image dimensions. By default, it uses the &quot;within&quot; constraint mode from imageflow, but that can be overriden:Graph.constrain(graph, 800, 600, %{mode: &quot;fit&quot;, gravity: %{percentage: %{x: 50, y: 50}}Check the JSON API docs for the constrain operation for more info on all options available","ref":"Imageflow.Graph.html#constrain/4","title":"Imageflow.Graph.constrain/4","type":"function"},{"doc":"Adjusts contrast betweeen -1 and 1","ref":"Imageflow.Graph.html#contrast/2","title":"Imageflow.Graph.contrast/2","type":"function"},{"doc":"","ref":"Imageflow.Graph.html#crop_whitespace/3","title":"Imageflow.Graph.crop_whitespace/3","type":"function"},{"doc":"Appends a new input file to be decoded","ref":"Imageflow.Graph.html#decode_file/2","title":"Imageflow.Graph.decode_file/2","type":"function"},{"doc":"Specifies a destination file for the current branch of the pipelineNo further processing operations should be appended at the current branch after this call.The last two arguments specify the encoder and optional encoding parameters.The following parameters are valid encoders::jpg: Alias to :mozjpeg:jpeg: Alias to :mozjpeg:png: Alias to :lodepng:webp: Alias to:webplossless:mozjpeg:gif:lodepng: Lossless PNG:pngquant: Lossy PNG:webplossy: Lossy WebP:webplossless: Lossless WebPCheck the official encoding documentation to see the parameters available to each encoder","ref":"Imageflow.Graph.html#encode_to_file/4","title":"Imageflow.Graph.encode_to_file/4","type":"function"},{"doc":"Resizes the canvas according to the given amounts for each direction, filling in the empty space with the given HEX color","ref":"Imageflow.Graph.html#expand_canvas/6","title":"Imageflow.Graph.expand_canvas/6","type":"function"},{"doc":"Draws a of the given color int he given coordinates","ref":"Imageflow.Graph.html#fill_rect/6","title":"Imageflow.Graph.fill_rect/6","type":"function"},{"doc":"Flips the image horizontally","ref":"Imageflow.Graph.html#flip_horizontal/1","title":"Imageflow.Graph.flip_horizontal/1","type":"function"},{"doc":"Flips the image vertically","ref":"Imageflow.Graph.html#flip_vertical/1","title":"Imageflow.Graph.flip_vertical/1","type":"function"},{"doc":"Creates a new graph instance","ref":"Imageflow.Graph.html#new/0","title":"Imageflow.Graph.new/0","type":"function"},{"doc":"Like a crop command, but you can specify coordinates outside of the image and thereby add padding. It's like a window.","ref":"Imageflow.Graph.html#region/6","title":"Imageflow.Graph.region/6","type":"function"},{"doc":"","ref":"Imageflow.Graph.html#region_percent/6","title":"Imageflow.Graph.region_percent/6","type":"function"},{"doc":"Rotates image 180 degrees","ref":"Imageflow.Graph.html#rotate_180/1","title":"Imageflow.Graph.rotate_180/1","type":"function"},{"doc":"Rotates image 270 degrees","ref":"Imageflow.Graph.html#rotate_270/1","title":"Imageflow.Graph.rotate_270/1","type":"function"},{"doc":"Rotates image 90 degrees","ref":"Imageflow.Graph.html#rotate_90/1","title":"Imageflow.Graph.rotate_90/1","type":"function"},{"doc":"","ref":"Imageflow.Graph.html#run/1","title":"Imageflow.Graph.run/1","type":"function"},{"doc":"Adjusts saturation betweeen -1 and 1","ref":"Imageflow.Graph.html#saturation/2","title":"Imageflow.Graph.saturation/2","type":"function"},{"doc":"Adjusts the alpha channel of the image, from 0 (transparent) to 1 (opaque)","ref":"Imageflow.Graph.html#transparency/2","title":"Imageflow.Graph.transparency/2","type":"function"},{"doc":"Transposes the image","ref":"Imageflow.Graph.html#transpose/1","title":"Imageflow.Graph.transpose/1","type":"function"},{"doc":"","ref":"Imageflow.Graph.html#t:point_t/0","title":"Imageflow.Graph.point_t/0","type":"type"},{"doc":"","ref":"Imageflow.Graph.html#t:t/0","title":"Imageflow.Graph.t/0","type":"type"},{"doc":"","ref":"Imageflow.GraphRunner.html","title":"Imageflow.GraphRunner","type":"module"},{"doc":"","ref":"Imageflow.GraphRunner.html#run/1","title":"Imageflow.GraphRunner.run/1","type":"function"},{"doc":"","ref":"Imageflow.NIF.html","title":"Imageflow.NIF","type":"module"},{"doc":"","ref":"Imageflow.NIF.html#error/0","title":"Imageflow.NIF.error/0","type":"function"},{"doc":"","ref":"Imageflow.NIF.html#get_long_version_string/0","title":"Imageflow.NIF.get_long_version_string/0","type":"function"},{"doc":"","ref":"Imageflow.NIF.html#job_add_input_buffer/3","title":"Imageflow.NIF.job_add_input_buffer/3","type":"function"},{"doc":"","ref":"Imageflow.NIF.html#job_add_input_file/3","title":"Imageflow.NIF.job_add_input_file/3","type":"function"},{"doc":"","ref":"Imageflow.NIF.html#job_add_output_buffer/2","title":"Imageflow.NIF.job_add_output_buffer/2","type":"function"},{"doc":"","ref":"Imageflow.NIF.html#job_create/0","title":"Imageflow.NIF.job_create/0","type":"function"},{"doc":"","ref":"Imageflow.NIF.html#job_destroy/1","title":"Imageflow.NIF.job_destroy/1","type":"function"},{"doc":"","ref":"Imageflow.NIF.html#job_get_output_buffer/2","title":"Imageflow.NIF.job_get_output_buffer/2","type":"function"},{"doc":"","ref":"Imageflow.NIF.html#job_message/3","title":"Imageflow.NIF.job_message/3","type":"function"},{"doc":"","ref":"Imageflow.NIF.html#job_save_output_to_file/3","title":"Imageflow.NIF.job_save_output_to_file/3","type":"function"},{"doc":"Low-level FFI bindings to imageflowExample usage:alias Imageflow.Native # create a job {:ok, job} = Native.create() # add an input file, with id `0` :ok = Native.add_input_file(job, 0, &quot;input.jpg&quot;) # you could also add input buffers directly from memory :ok = Native.add_input_buffer(job, 1, &lt;&lt;0x89, 0x50, 0x4E, 0x47, 0x0D, ... &gt;&gt;) # call `get_image_info` on buffer with id 0 {:ok, resp} = Native.message(&quot;v0.1/get_image_info&quot;, %{io_id: 0})","ref":"Imageflow.Native.html","title":"Imageflow.Native","type":"module"},{"doc":"","ref":"Imageflow.Native.html#add_input_buffer/3","title":"Imageflow.Native.add_input_buffer/3","type":"function"},{"doc":"","ref":"Imageflow.Native.html#add_input_file/3","title":"Imageflow.Native.add_input_file/3","type":"function"},{"doc":"","ref":"Imageflow.Native.html#add_output_buffer/2","title":"Imageflow.Native.add_output_buffer/2","type":"function"},{"doc":"","ref":"Imageflow.Native.html#create/0","title":"Imageflow.Native.create/0","type":"function"},{"doc":"","ref":"Imageflow.Native.html#create!/0","title":"Imageflow.Native.create!/0","type":"function"},{"doc":"","ref":"Imageflow.Native.html#destroy/1","title":"Imageflow.Native.destroy/1","type":"function"},{"doc":"","ref":"Imageflow.Native.html#get_output_buffer/2","title":"Imageflow.Native.get_output_buffer/2","type":"function"},{"doc":"","ref":"Imageflow.Native.html#message/3","title":"Imageflow.Native.message/3","type":"function"},{"doc":"","ref":"Imageflow.Native.html#save_output_to_file/3","title":"Imageflow.Native.save_output_to_file/3","type":"function"},{"doc":"","ref":"Imageflow.Native.html#t:native_ret_t/0","title":"Imageflow.Native.native_ret_t/0","type":"type"},{"doc":"","ref":"Imageflow.Native.html#t:t/0","title":"Imageflow.Native.t/0","type":"type"},{"doc":"ImageflowEx Elixir bindings for Imageflow, a safe and blazing fast image workflow library.","ref":"readme.html","title":"ImageflowEx","type":"extras"},{"doc":"Add the package to your mix.exs:def deps do [ {:imageflow, &quot;~&gt; 0.4.1&quot;} ] end","ref":"readme.html#installation","title":"ImageflowEx - Installation","type":"extras"},{"doc":"There are two main ways of using imageflow_ex:Imageflow.Graph, which is the high-level graph-like API, inspired by Imageflow.NETImageflow.Native which provides lower-level access to Rust binding. Shouldn't be needed unless you need really specific features which aren't yet implemented in the Graph API (but please open an issue so the API can evolve).Using the Graph API allows you to create processing pipelines to process your images:alias Imageflow.Graph Graph.new() |&gt; Graph.decode_file(&quot;input.png&quot;) # read input.png |&gt; Graph.constrain(200, 200) # constrain image to 200x200 |&gt; Graph.saturation(0.5) # set saturation to 0.5 (-1..1 range) |&gt; Graph.encode_to_file(&quot;output.png&quot;) # specify output file |&gt; Graph.run() # run the jobLow-level APIThis provides direct access to NIF bindings. You probably don't need this, unless you're relying on APIs that are not yet supported by the Graph API (please submit an issue).Check Imageflow.Native for documentation and examples.","ref":"readme.html#usage","title":"ImageflowEx - Usage","type":"extras"},{"doc":"Feel free to contribute. Either by opening an issue, a Pull Request, or contacting the author directlyIf you found a bug, please open an issue. You can also open a PR for bugs or new features. PRs will be reviewed and subject to our style guide and linters.AboutThis project was developed by Miguel Palhas, and is published under the ISC license.","ref":"readme.html#contributing","title":"ImageflowEx - Contributing","type":"extras"}]